import{S as xi,i as Si,s as qi,e as r,k as d,w as k,t as o,M as Oi,c as n,d as a,m as u,a as l,x as D,h as s,b as f,G as t,g as h,y as L,q as R,o as j,B as T,v as Ci,L as Mi}from"../../chunks/vendor-hf-doc-builder.js";import{T as sa}from"../../chunks/Tip-hf-doc-builder.js";import{I as Rt}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as Y}from"../../chunks/CodeBlock-hf-doc-builder.js";import{D as Ni}from"../../chunks/DocNotebookDropdown-hf-doc-builder.js";function Ii(I){let p,y,c,b,v;return{c(){p=r("p"),y=o("Currently, LoRA is only supported for the attention layers of the "),c=r("code"),b=o("UNet2DConditionalModel"),v=o(`. We also
support fine-tuning the text encoder for DreamBooth with LoRA in a limited capacity. Fine-tuning the text encoder for DreamBooth generally yields better results, but it can increase compute usage.`)},l(m){p=n(m,"P",{});var g=l(p);y=s(g,"Currently, LoRA is only supported for the attention layers of the "),c=n(g,"CODE",{});var E=l(c);b=s(E,"UNet2DConditionalModel"),E.forEach(a),v=s(g,`. We also
support fine-tuning the text encoder for DreamBooth with LoRA in a limited capacity. Fine-tuning the text encoder for DreamBooth generally yields better results, but it can increase compute usage.`),g.forEach(a)},m(m,g){h(m,p,g),t(p,y),t(p,c),t(c,b),t(p,v)},d(m){m&&a(p)}}}function Ui(I){let p,y,c,b,v;return{c(){p=r("p"),y=o(`\u{1F4A1} LoRA is not only limited to attention layers. The authors found that amending
the attention layers of a language model is sufficient to obtain good downstream performance with great efficiency. This is why it\u2019s common to just add the LoRA weights to the attention layers of a model. Check out the `),c=r("a"),b=o("Using LoRA for efficient Stable Diffusion fine-tuning"),v=o(" blog for more information about how LoRA works!"),this.h()},l(m){p=n(m,"P",{});var g=l(p);y=s(g,`\u{1F4A1} LoRA is not only limited to attention layers. The authors found that amending
the attention layers of a language model is sufficient to obtain good downstream performance with great efficiency. This is why it\u2019s common to just add the LoRA weights to the attention layers of a model. Check out the `),c=n(g,"A",{href:!0,rel:!0});var E=l(c);b=s(E,"Using LoRA for efficient Stable Diffusion fine-tuning"),E.forEach(a),v=s(g," blog for more information about how LoRA works!"),g.forEach(a),this.h()},h(){f(c,"href","https://huggingface.co/blog/lora"),f(c,"rel","nofollow")},m(m,g){h(m,p,g),t(p,y),t(p,c),t(c,b),t(p,v)},d(m){m&&a(p)}}}function Bi(I){let p,y,c,b,v,m,g,E,P,x,S,w,$,O,A,C,V,M,B,X;return{c(){p=r("p"),y=o("\u{1F4A1} A "),c=r("code"),b=o("scale"),v=o(" value of "),m=r("code"),g=o("0"),E=o(" is the same as not using your LoRA weights and you\u2019re only using the base model weights, and a "),P=r("code"),x=o("scale"),S=o(" value of "),w=r("code"),$=o("1"),O=o(" means you\u2019re only using the fully finetuned LoRA weights. Values between "),A=r("code"),C=o("0"),V=o(" and "),M=r("code"),B=o("1"),X=o(" interpolates between the two weights.")},l(N){p=n(N,"P",{});var _=l(p);y=s(_,"\u{1F4A1} A "),c=n(_,"CODE",{});var pe=l(c);b=s(pe,"scale"),pe.forEach(a),v=s(_," value of "),m=n(_,"CODE",{});var fe=l(m);g=s(fe,"0"),fe.forEach(a),E=s(_," is the same as not using your LoRA weights and you\u2019re only using the base model weights, and a "),P=n(_,"CODE",{});var J=l(P);x=s(J,"scale"),J.forEach(a),S=s(_," value of "),w=n(_,"CODE",{});var q=l(w);$=s(q,"1"),q.forEach(a),O=s(_," means you\u2019re only using the fully finetuned LoRA weights. Values between "),A=n(_,"CODE",{});var H=l(A);C=s(H,"0"),H.forEach(a),V=s(_," and "),M=n(_,"CODE",{});var de=l(M);B=s(de,"1"),de.forEach(a),X=s(_," interpolates between the two weights."),_.forEach(a)},m(N,_){h(N,p,_),t(p,y),t(p,c),t(c,b),t(p,v),t(p,m),t(m,g),t(p,E),t(p,P),t(P,x),t(p,S),t(p,w),t(w,$),t(p,O),t(p,A),t(A,C),t(p,V),t(p,M),t(M,B),t(p,X)},d(N){N&&a(p)}}}function Hi(I){let p,y,c,b,v,m,g,E,P,x,S;return x=new Y({props:{code:`from huggingface_hub.repocard import RepoCard

lora_model_id = "sayakpaul/sd-model-finetuned-lora-t4"
card = RepoCard.load(lora_model_id)
base_model_id = card.data.to_dict()["base_model"]

pipe = StableDiffusionPipeline.from_pretrained(base_model_id, torch_dtype=torch.float16)
...`,highlighted:`<span class="hljs-keyword">from</span> huggingface_hub.repocard <span class="hljs-keyword">import</span> RepoCard

lora_model_id = <span class="hljs-string">&quot;sayakpaul/sd-model-finetuned-lora-t4&quot;</span>
card = RepoCard.load(lora_model_id)
base_model_id = card.data.to_dict()[<span class="hljs-string">&quot;base_model&quot;</span>]

pipe = StableDiffusionPipeline.from_pretrained(base_model_id, torch_dtype=torch.float16)
...`}}),{c(){p=r("p"),y=o(`If you are loading the LoRA parameters from the Hub and if the Hub repository has
a `),c=r("code"),b=o("base_model"),v=o(" tag (such as "),m=r("a"),g=o("this"),E=o(`), then
you can do:`),P=d(),k(x.$$.fragment),this.h()},l(w){p=n(w,"P",{});var $=l(p);y=s($,`If you are loading the LoRA parameters from the Hub and if the Hub repository has
a `),c=n($,"CODE",{});var O=l(c);b=s(O,"base_model"),O.forEach(a),v=s($," tag (such as "),m=n($,"A",{href:!0,rel:!0});var A=l(m);g=s(A,"this"),A.forEach(a),E=s($,`), then
you can do:`),$.forEach(a),P=u(w),D(x.$$.fragment,w),this.h()},h(){f(m,"href","https://huggingface.co/sayakpaul/sd-model-finetuned-lora-t4/blob/main/README.md?code=true#L4"),f(m,"rel","nofollow")},m(w,$){h(w,p,$),t(p,y),t(p,c),t(c,b),t(p,v),t(p,m),t(m,g),t(p,E),h(w,P,$),L(x,w,$),S=!0},p:Mi,i(w){S||(R(x.$$.fragment,w),S=!0)},o(w){j(x.$$.fragment,w),S=!1},d(w){w&&a(p),w&&a(P),T(x,w)}}}function Gi(I){let p,y,c,b,v;return{c(){p=r("p"),y=o("\u{1F4A1} Take a look at the "),c=r("a"),b=o("Training Stable Diffusion with DreamBooth using \u{1F9E8} Diffusers"),v=o(" blog for an in-depth analysis of DreamBooth experiments and recommended settings."),this.h()},l(m){p=n(m,"P",{});var g=l(p);y=s(g,"\u{1F4A1} Take a look at the "),c=n(g,"A",{href:!0,rel:!0});var E=l(c);b=s(E,"Training Stable Diffusion with DreamBooth using \u{1F9E8} Diffusers"),E.forEach(a),v=s(g," blog for an in-depth analysis of DreamBooth experiments and recommended settings."),g.forEach(a),this.h()},h(){f(c,"href","https://huggingface.co/blog/dreambooth"),f(c,"rel","nofollow")},m(m,g){h(m,p,g),t(p,y),t(p,c),t(c,b),t(p,v)},d(m){m&&a(p)}}}function zi(I){let p,y,c,b,v,m,g,E,P,x,S,w,$,O,A,C,V,M,B,X;return{c(){p=r("p"),y=o("\u{1F4A1} A "),c=r("code"),b=o("scale"),v=o(" value of "),m=r("code"),g=o("0"),E=o(" is the same as not using your LoRA weights and you\u2019re only using the base model weights, and a "),P=r("code"),x=o("scale"),S=o(" value of "),w=r("code"),$=o("1"),O=o(" means you\u2019re only using the fully finetuned LoRA weights. Values between "),A=r("code"),C=o("0"),V=o(" and "),M=r("code"),B=o("1"),X=o(" interpolates between the two weights.")},l(N){p=n(N,"P",{});var _=l(p);y=s(_,"\u{1F4A1} A "),c=n(_,"CODE",{});var pe=l(c);b=s(pe,"scale"),pe.forEach(a),v=s(_," value of "),m=n(_,"CODE",{});var fe=l(m);g=s(fe,"0"),fe.forEach(a),E=s(_," is the same as not using your LoRA weights and you\u2019re only using the base model weights, and a "),P=n(_,"CODE",{});var J=l(P);x=s(J,"scale"),J.forEach(a),S=s(_," value of "),w=n(_,"CODE",{});var q=l(w);$=s(q,"1"),q.forEach(a),O=s(_," means you\u2019re only using the fully finetuned LoRA weights. Values between "),A=n(_,"CODE",{});var H=l(A);C=s(H,"0"),H.forEach(a),V=s(_," and "),M=n(_,"CODE",{});var de=l(M);B=s(de,"1"),de.forEach(a),X=s(_," interpolates between the two weights."),_.forEach(a)},m(N,_){h(N,p,_),t(p,y),t(p,c),t(c,b),t(p,v),t(p,m),t(m,g),t(p,E),t(p,P),t(P,x),t(p,S),t(p,w),t(w,$),t(p,O),t(p,A),t(A,C),t(p,V),t(p,M),t(M,B),t(p,X)},d(N){N&&a(p)}}}function Wi(I){let p,y,c,b,v,m,g,E,P,x,S,w,$,O,A,C,V,M,B,X,N,_,pe,fe,J,q,H,de,He,hs,ps,fs,ra,ds,us,ue,cs,jt,ms,_s,na,gs,bs,ws,la,vs,ao,ye,oo,G,Ge,ys,$s,ze,Es,As,We,ks,Ds,Fe,Ls,Rs,so,$e,js,Tt,Ts,Ps,ro,Ye,no,ce,Ee,ia,Ve,xs,ha,Ss,lo,Pt,qs,io,me,Ae,pa,Xe,Os,fa,Cs,ho,K,Ms,Je,da,Ns,Is,Ke,Us,Bs,po,U,Hs,ua,Gs,zs,Ze,ca,Ws,Fs,ma,Ys,Vs,xt,Xs,Js,fo,Z,Ks,_a,Zs,Qs,ga,er,tr,uo,Qe,co,St,ar,mo,Q,qt,ba,or,sr,rr,ke,wa,nr,lr,et,ir,hr,pr,Ot,va,fr,dr,_o,ee,ur,tt,cr,mr,ya,_r,gr,go,at,bo,_e,De,$a,ot,br,Ea,wr,wo,te,vr,Ct,yr,$r,Mt,Er,Ar,vo,st,yo,ae,kr,Aa,Dr,Lr,ka,Rr,jr,$o,Le,Eo,rt,Ao,Re,ko,ge,je,Da,nt,Tr,La,Pr,Do,lt,it,xr,Sr,Lo,Te,Ro,be,Pe,Ra,ht,qr,ja,Or,jo,z,Cr,pt,Ta,Mr,Nr,ft,Ir,Ur,Nt,Br,Hr,To,W,Gr,Pa,zr,Wr,dt,xa,Fr,Yr,Sa,Vr,Xr,Po,xe,Jr,qa,Kr,Zr,xo,ut,So,It,Qr,qo,oe,Ut,Oa,en,tn,an,Se,Ca,on,sn,ct,rn,nn,ln,Bt,Ma,hn,pn,Oo,se,fn,mt,dn,un,Na,cn,mn,Co,re,_n,Ia,gn,bn,Ua,wn,vn,Mo,_t,No,we,qe,Ba,gt,yn,Ha,$n,Io,Oe,En,Ht,An,kn,Uo,bt,Bo,ne,Dn,Ga,Ln,Rn,za,jn,Tn,Ho,Ce,Go,wt,zo,le,Pn,Wa,xn,Sn,Fa,qn,On,Wo,vt,Fo,F,Cn,Gt,Mn,Nn,zt,In,Un,Wt,Bn,Hn,Yo,Me,yt,$t,Gn,Et,Ya,zn,Wn,Fn,At,Yn,Va,kt,Vn,Dt,Xa,Xn,Jn,Vo;return m=new Rt({}),S=new Ni({props:{classNames:"absolute z-10 right-0 top-0",options:[{label:"Mixed",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/en/lora.ipynb"},{label:"PyTorch",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/en/pytorch/lora.ipynb"},{label:"TensorFlow",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/en/tensorflow/lora.ipynb"},{label:"Mixed",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/en/lora.ipynb"},{label:"PyTorch",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/en/pytorch/lora.ipynb"},{label:"TensorFlow",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/en/tensorflow/lora.ipynb"}]}}),$=new sa({props:{warning:!0,$$slots:{default:[Ii]},$$scope:{ctx:I}}}),ye=new sa({props:{$$slots:{default:[Ui]},$$scope:{ctx:I}}}),Ye=new Y({props:{code:"huggingface-cli login",highlighted:"huggingface-cli login"}}),Ve=new Rt({}),Xe=new Rt({}),Qe=new Y({props:{code:`export MODEL_NAME="runwayml/stable-diffusion-v1-5"
export OUTPUT_DIR="/sddata/finetune/lora/pokemon"
export HUB_MODEL_ID="pokemon-lora"
export DATASET_NAME="lambdalabs/pokemon-blip-captions"`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;/sddata/finetune/lora/pokemon&quot;</span>
<span class="hljs-built_in">export</span> HUB_MODEL_ID=<span class="hljs-string">&quot;pokemon-lora&quot;</span>
<span class="hljs-built_in">export</span> DATASET_NAME=<span class="hljs-string">&quot;lambdalabs/pokemon-blip-captions&quot;</span>`}}),at=new Y({props:{code:`accelerate launch --mixed_precision="fp16"  train_text_to_image_lora.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --dataset_name=$DATASET_NAME \\
  --dataloader_num_workers=8 \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --max_train_steps=15000 \\
  --learning_rate=1e-04 \\
  --max_grad_norm=1 \\
  --lr_scheduler="cosine" --lr_warmup_steps=0 \\
  --output_dir=\${OUTPUT_DIR} \\
  --push_to_hub \\
  --hub_model_id=\${HUB_MODEL_ID} \\
  --report_to=wandb \\
  --checkpointing_steps=500 \\
  --validation_prompt="A pokemon with blue eyes." \\
  --seed=1337`,highlighted:`accelerate launch --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span>  train_text_to_image_lora.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --dataset_name=<span class="hljs-variable">$DATASET_NAME</span> \\
  --dataloader_num_workers=8 \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --max_train_steps=15000 \\
  --learning_rate=1e-04 \\
  --max_grad_norm=1 \\
  --lr_scheduler=<span class="hljs-string">&quot;cosine&quot;</span> --lr_warmup_steps=0 \\
  --output_dir=<span class="hljs-variable">\${OUTPUT_DIR}</span> \\
  --push_to_hub \\
  --hub_model_id=<span class="hljs-variable">\${HUB_MODEL_ID}</span> \\
  --report_to=wandb \\
  --checkpointing_steps=500 \\
  --validation_prompt=<span class="hljs-string">&quot;A pokemon with blue eyes.&quot;</span> \\
  --seed=1337`}}),ot=new Rt({}),st=new Y({props:{code:`import torch
from diffusers import StableDiffusionPipeline, DPMSolverMultistepScheduler

model_base = "runwayml/stable-diffusion-v1-5"

pipe = StableDiffusionPipeline.from_pretrained(model_base, torch_dtype=torch.float16)
pipe.scheduler = DPMSolverMultistepScheduler.from_config(pipe.scheduler.config)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline, DPMSolverMultistepScheduler

<span class="hljs-meta">&gt;&gt;&gt; </span>model_base = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionPipeline.from_pretrained(model_base, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.scheduler = DPMSolverMultistepScheduler.from_config(pipe.scheduler.config)`}}),Le=new sa({props:{$$slots:{default:[Bi]},$$scope:{ctx:I}}}),rt=new Y({props:{code:`pipe.unet.load_attn_procs(lora_model_path)
pipe.to("cuda")

image = pipe(
    "A pokemon with blue eyes.", num_inference_steps=25, guidance_scale=7.5, cross_attention_kwargs={"scale": 0.5}
).images[0]

image = pipe("A pokemon with blue eyes.", num_inference_steps=25, guidance_scale=7.5).images[0]
image.save("blue_pokemon.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.unet.load_attn_procs(lora_model_path)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-comment"># use half the weights from the LoRA finetuned model and half the weights from the base model</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;A pokemon with blue eyes.&quot;</span>, num_inference_steps=<span class="hljs-number">25</span>, guidance_scale=<span class="hljs-number">7.5</span>, cross_attention_kwargs={<span class="hljs-string">&quot;scale&quot;</span>: <span class="hljs-number">0.5</span>}
<span class="hljs-meta">... </span>).images[<span class="hljs-number">0</span>]
<span class="hljs-comment"># use the weights from the fully finetuned LoRA model</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(<span class="hljs-string">&quot;A pokemon with blue eyes.&quot;</span>, num_inference_steps=<span class="hljs-number">25</span>, guidance_scale=<span class="hljs-number">7.5</span>).images[<span class="hljs-number">0</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image.save(<span class="hljs-string">&quot;blue_pokemon.png&quot;</span>)`}}),Re=new sa({props:{$$slots:{default:[Hi]},$$scope:{ctx:I}}}),nt=new Rt({}),Te=new sa({props:{$$slots:{default:[Gi]},$$scope:{ctx:I}}}),ht=new Rt({}),ut=new Y({props:{code:`export MODEL_NAME="runwayml/stable-diffusion-v1-5"
export INSTANCE_DIR="path-to-instance-images"
export OUTPUT_DIR="path-to-save-model"`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path-to-instance-images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path-to-save-model&quot;</span>`}}),_t=new Y({props:{code:`accelerate launch train_dreambooth_lora.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --instance_prompt="a photo of sks dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 \\
  --checkpointing_steps=100 \\
  --learning_rate=1e-4 \\
  --report_to="wandb" \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --max_train_steps=500 \\
  --validation_prompt="A photo of sks dog in a bucket" \\
  --validation_epochs=50 \\
  --seed="0" \\
  --push_to_hub`,highlighted:`accelerate launch train_dreambooth_lora.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 \\
  --checkpointing_steps=100 \\
  --learning_rate=1e-4 \\
  --report_to=<span class="hljs-string">&quot;wandb&quot;</span> \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --max_train_steps=500 \\
  --validation_prompt=<span class="hljs-string">&quot;A photo of sks dog in a bucket&quot;</span> \\
  --validation_epochs=50 \\
  --seed=<span class="hljs-string">&quot;0&quot;</span> \\
  --push_to_hub`}}),gt=new Rt({}),bt=new Y({props:{code:`import torch
from diffusers import StableDiffusionPipeline

model_base = "runwayml/stable-diffusion-v1-5"

pipe = StableDiffusionPipeline.from_pretrained(model_base, torch_dtype=torch.float16)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span>model_base = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionPipeline.from_pretrained(model_base, torch_dtype=torch.float16)`}}),Ce=new sa({props:{$$slots:{default:[zi]},$$scope:{ctx:I}}}),wt=new Y({props:{code:`pipe.unet.load_attn_procs(lora_model_path)
pipe.to("cuda")

image = pipe(
    "A picture of a sks dog in a bucket.",
    num_inference_steps=25,
    guidance_scale=7.5,
    cross_attention_kwargs={"scale": 0.5},
).images[0]

image = pipe("A picture of a sks dog in a bucket.", num_inference_steps=25, guidance_scale=7.5).images[0]
image.save("bucket-dog.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.unet.load_attn_procs(lora_model_path)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-comment"># use half the weights from the LoRA finetuned model and half the weights from the base model</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;A picture of a sks dog in a bucket.&quot;</span>,
<span class="hljs-meta">... </span>    num_inference_steps=<span class="hljs-number">25</span>,
<span class="hljs-meta">... </span>    guidance_scale=<span class="hljs-number">7.5</span>,
<span class="hljs-meta">... </span>    cross_attention_kwargs={<span class="hljs-string">&quot;scale&quot;</span>: <span class="hljs-number">0.5</span>},
<span class="hljs-meta">... </span>).images[<span class="hljs-number">0</span>]
<span class="hljs-comment"># use the weights from the fully finetuned LoRA model</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(<span class="hljs-string">&quot;A picture of a sks dog in a bucket.&quot;</span>, num_inference_steps=<span class="hljs-number">25</span>, guidance_scale=<span class="hljs-number">7.5</span>).images[<span class="hljs-number">0</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image.save(<span class="hljs-string">&quot;bucket-dog.png&quot;</span>)`}}),vt=new Y({props:{code:`from huggingface_hub.repocard import RepoCard
from diffusers import StableDiffusionPipeline
import torch

lora_model_id = "sayakpaul/dreambooth-text-encoder-test"
card = RepoCard.load(lora_model_id)
base_model_id = card.data.to_dict()["base_model"]

pipe = StableDiffusionPipeline.from_pretrained(base_model_id, torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.load_lora_weights(lora_model_id)
image = pipe("A picture of a sks dog in a bucket", num_inference_steps=25).images[0]`,highlighted:`<span class="hljs-keyword">from</span> huggingface_hub.repocard <span class="hljs-keyword">import</span> RepoCard
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

lora_model_id = <span class="hljs-string">&quot;sayakpaul/dreambooth-text-encoder-test&quot;</span>
card = RepoCard.load(lora_model_id)
base_model_id = card.data.to_dict()[<span class="hljs-string">&quot;base_model&quot;</span>]

pipe = StableDiffusionPipeline.from_pretrained(base_model_id, torch_dtype=torch.float16)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
pipe.load_lora_weights(lora_model_id)
image = pipe(<span class="hljs-string">&quot;A picture of a sks dog in a bucket&quot;</span>, num_inference_steps=<span class="hljs-number">25</span>).images[<span class="hljs-number">0</span>]`}}),At=new Y({props:{code:"pipe.load_lora_weights(lora_model_path)",highlighted:"pipe.load_lora_weights(lora_model_path)"}}),{c(){p=r("meta"),y=d(),c=r("h1"),b=r("a"),v=r("span"),k(m.$$.fragment),g=d(),E=r("span"),P=o("Low-Rank Adaptation of Large Language Models (LoRA)"),x=d(),k(S.$$.fragment),w=d(),k($.$$.fragment),O=d(),A=r("p"),C=r("a"),V=o("Low-Rank Adaptation of Large Language Models (LoRA)"),M=o(" is a training method that accelerates the training of large models while consuming less memory. It adds pairs of rank-decomposition weight matrices (called "),B=r("strong"),X=o("update matrices"),N=o(") to existing weights, and "),_=r("strong"),pe=o("only"),fe=o(" trains those newly added weights. This has a couple of advantages:"),J=d(),q=r("ul"),H=r("li"),de=o("Previous pretrained weights are kept frozen so the model is not as prone to "),He=r("a"),hs=o("catastrophic forgetting"),ps=o("."),fs=d(),ra=r("li"),ds=o("Rank-decomposition matrices have significantly fewer parameters than the original model, which means that trained LoRA weights are easily portable."),us=d(),ue=r("li"),cs=o("LoRA matrices are generally added to the attention layers of the original model. \u{1F9E8} Diffusers provides the "),jt=r("a"),ms=o("load_attn_procs()"),_s=o(" method to load the LoRA weights into a model\u2019s attention layers. You can control the extent to which the model is adapted toward new training images via a "),na=r("code"),gs=o("scale"),bs=o(" parameter."),ws=d(),la=r("li"),vs=o("The greater memory-efficiency allows you to run fine-tuning on consumer GPUs like the Tesla T4, RTX 3080 or even the RTX 2080 Ti! GPUs like the T4 are free and readily accessible in Kaggle or Google Colab notebooks."),ao=d(),k(ye.$$.fragment),oo=d(),G=r("p"),Ge=r("a"),ys=o("cloneofsimo"),$s=o(" was the first to try out LoRA training for Stable Diffusion in the popular "),ze=r("a"),Es=o("lora"),As=o(" GitHub repository. \u{1F9E8} Diffusers now supports finetuning with LoRA for "),We=r("a"),ks=o("text-to-image generation"),Ds=o(" and "),Fe=r("a"),Ls=o("DreamBooth"),Rs=o(". This guide will show you how to do both."),so=d(),$e=r("p"),js=o("If you\u2019d like to store or share your model with the community, login to your Hugging Face account (create "),Tt=r("a"),Ts=o("one"),Ps=o(" if you don\u2019t have one already):"),ro=d(),k(Ye.$$.fragment),no=d(),ce=r("h2"),Ee=r("a"),ia=r("span"),k(Ve.$$.fragment),xs=d(),ha=r("span"),Ss=o("Text-to-image"),lo=d(),Pt=r("p"),qs=o("Finetuning a model like Stable Diffusion, which has billions of parameters, can be slow and difficult. With LoRA, it is much easier and faster to finetune a diffusion model. It can run on hardware with as little as 11GB of GPU RAM without resorting to tricks such as 8-bit optimizers."),io=d(),me=r("h3"),Ae=r("a"),pa=r("span"),k(Xe.$$.fragment),Os=d(),fa=r("span"),Cs=o("Training"),ho=d(),K=r("p"),Ms=o("Let\u2019s finetune "),Je=r("a"),da=r("code"),Ns=o("stable-diffusion-v1-5"),Is=o(" on the "),Ke=r("a"),Us=o("Pok\xE9mon BLIP captions"),Bs=o(" dataset to generate your own Pok\xE9mon."),po=d(),U=r("p"),Hs=o("Specify the "),ua=r("code"),Gs=o("MODEL_NAME"),zs=o(" environment variable (either a Hub model repository id or a path to the directory containing the model weights) and pass it to the "),Ze=r("a"),ca=r("code"),Ws=o("pretrained_model_name_or_path"),Fs=o(" argument. You\u2019ll also need to set the "),ma=r("code"),Ys=o("DATASET_NAME"),Vs=o(" environment variable to the name of the dataset you want to train on. To use your own dataset, take a look at the "),xt=r("a"),Xs=o("Create a dataset for training"),Js=o(" guide."),fo=d(),Z=r("p"),Ks=o("The "),_a=r("code"),Zs=o("OUTPUT_DIR"),Qs=o(" and "),ga=r("code"),er=o("HUB_MODEL_ID"),tr=o(" variables are optional and specify where to save the model to on the Hub:"),uo=d(),k(Qe.$$.fragment),co=d(),St=r("p"),ar=o("There are some flags to be aware of before you start training:"),mo=d(),Q=r("ul"),qt=r("li"),ba=r("code"),or=o("--push_to_hub"),sr=o(" stores the trained LoRA embeddings on the Hub."),rr=d(),ke=r("li"),wa=r("code"),nr=o("--report_to=wandb"),lr=o(" reports and logs the training results to your Weights & Biases dashboard (as an example, take a look at this "),et=r("a"),ir=o("report"),hr=o(")."),pr=d(),Ot=r("li"),va=r("code"),fr=o("--learning_rate=1e-04"),dr=o(", you can afford to use a higher learning rate than you normally would with LoRA."),_o=d(),ee=r("p"),ur=o("Now you\u2019re ready to launch the training (you can find the full training script "),tt=r("a"),cr=o("here"),mr=o("). Training takes about 5 hours on a 2080 Ti GPU with 11GB of RAM, and it\u2019ll create and save model checkpoints and the "),ya=r("code"),_r=o("pytorch_lora_weights"),gr=o(" in your repository."),go=d(),k(at.$$.fragment),bo=d(),_e=r("h3"),De=r("a"),$a=r("span"),k(ot.$$.fragment),br=d(),Ea=r("span"),wr=o("Inference"),wo=d(),te=r("p"),vr=o("Now you can use the model for inference by loading the base model in the "),Ct=r("a"),yr=o("StableDiffusionPipeline"),$r=o(" and then the "),Mt=r("a"),Er=o("DPMSolverMultistepScheduler"),Ar=o(":"),vo=d(),k(st.$$.fragment),yo=d(),ae=r("p"),kr=o("Load the LoRA weights from your finetuned model "),Aa=r("em"),Dr=o("on top of the base model weights"),Lr=o(", and then move the pipeline to a GPU for faster inference. When you merge the LoRA weights with the frozen pretrained model weights, you can optionally adjust how much of the weights to merge with the "),ka=r("code"),Rr=o("scale"),jr=o(" parameter:"),$o=d(),k(Le.$$.fragment),Eo=d(),k(rt.$$.fragment),Ao=d(),k(Re.$$.fragment),ko=d(),ge=r("h2"),je=r("a"),Da=r("span"),k(nt.$$.fragment),Tr=d(),La=r("span"),Pr=o("DreamBooth"),Do=d(),lt=r("p"),it=r("a"),xr=o("DreamBooth"),Sr=o(" is a finetuning technique for personalizing a text-to-image model like Stable Diffusion to generate photorealistic images of a subject in different contexts, given a few images of the subject. However, DreamBooth is very sensitive to hyperparameters and it is easy to overfit. Some important hyperparameters to consider include those that affect the training time (learning rate, number of training steps), and inference time (number of steps, scheduler type)."),Lo=d(),k(Te.$$.fragment),Ro=d(),be=r("h3"),Pe=r("a"),Ra=r("span"),k(ht.$$.fragment),qr=d(),ja=r("span"),Or=o("Training"),jo=d(),z=r("p"),Cr=o("Let\u2019s finetune "),pt=r("a"),Ta=r("code"),Mr=o("stable-diffusion-v1-5"),Nr=o(" with DreamBooth and LoRA with some \u{1F436} "),ft=r("a"),Ir=o("dog images"),Ur=o(". Download and save these images to a directory. To use your own dataset, take a look at the "),Nt=r("a"),Br=o("Create a dataset for training"),Hr=o(" guide."),To=d(),W=r("p"),Gr=o("To start, specify the "),Pa=r("code"),zr=o("MODEL_NAME"),Wr=o(" environment variable (either a Hub model repository id or a path to the directory containing the model weights) and pass it to the "),dt=r("a"),xa=r("code"),Fr=o("pretrained_model_name_or_path"),Yr=o(" argument. You\u2019ll also need to set "),Sa=r("code"),Vr=o("INSTANCE_DIR"),Xr=o(" to the path of the directory containing the images."),Po=d(),xe=r("p"),Jr=o("The "),qa=r("code"),Kr=o("OUTPUT_DIR"),Zr=o(" variables is optional and specifies where to save the model to on the Hub:"),xo=d(),k(ut.$$.fragment),So=d(),It=r("p"),Qr=o("There are some flags to be aware of before you start training:"),qo=d(),oe=r("ul"),Ut=r("li"),Oa=r("code"),en=o("--push_to_hub"),tn=o(" stores the trained LoRA embeddings on the Hub."),an=d(),Se=r("li"),Ca=r("code"),on=o("--report_to=wandb"),sn=o(" reports and logs the training results to your Weights & Biases dashboard (as an example, take a look at this "),ct=r("a"),rn=o("report"),nn=o(")."),ln=d(),Bt=r("li"),Ma=r("code"),hn=o("--learning_rate=1e-04"),pn=o(", you can afford to use a higher learning rate than you normally would with LoRA."),Oo=d(),se=r("p"),fn=o("Now you\u2019re ready to launch the training (you can find the full training script "),mt=r("a"),dn=o("here"),un=o("). The script creates and saves model checkpoints and the "),Na=r("code"),cn=o("pytorch_lora_weights.bin"),mn=o(" file in your repository."),Co=d(),re=r("p"),_n=o(`It\u2019s also possible to additionally fine-tune the text encoder with LoRA. This, in most cases, leads
to better results with a slight increase in the compute. To allow fine-tuning the text encoder with LoRA,
specify the `),Ia=r("code"),gn=o("--train_text_encoder"),bn=o(" while launching the "),Ua=r("code"),wn=o("train_dreambooth_lora.py"),vn=o(" script."),Mo=d(),k(_t.$$.fragment),No=d(),we=r("h3"),qe=r("a"),Ba=r("span"),k(gt.$$.fragment),yn=d(),Ha=r("span"),$n=o("Inference"),Io=d(),Oe=r("p"),En=o("Now you can use the model for inference by loading the base model in the "),Ht=r("a"),An=o("StableDiffusionPipeline"),kn=o(":"),Uo=d(),k(bt.$$.fragment),Bo=d(),ne=r("p"),Dn=o("Load the LoRA weights from your finetuned DreamBooth model "),Ga=r("em"),Ln=o("on top of the base model weights"),Rn=o(", and then move the pipeline to a GPU for faster inference. When you merge the LoRA weights with the frozen pretrained model weights, you can optionally adjust how much of the weights to merge with the "),za=r("code"),jn=o("scale"),Tn=o(" parameter:"),Ho=d(),k(Ce.$$.fragment),Go=d(),k(wt.$$.fragment),zo=d(),le=r("p"),Pn=o("If you used "),Wa=r("code"),xn=o("--train_text_encoder"),Sn=o(" during training, then use "),Fa=r("code"),qn=o("pipe.load_lora_weights()"),On=o(` to load the LoRA
weights. For example:`),Wo=d(),k(vt.$$.fragment),Fo=d(),F=r("p"),Cn=o("Note that the use of "),Gt=r("a"),Mn=o("load_lora_weights()"),Nn=o(" is preferred to "),zt=r("a"),In=o("load_attn_procs()"),Un=o(` for loading LoRA parameters. This is because
`),Wt=r("a"),Bn=o("load_lora_weights()"),Hn=o(" can handle the following situations:"),Yo=d(),Me=r("ul"),yt=r("li"),$t=r("p"),Gn=o("LoRA parameters that don\u2019t have separate identifiers for the UNet and the text encoder (such as "),Et=r("a"),Ya=r("code"),zn=o('"patrickvonplaten/lora_dreambooth_dog_example"'),Wn=o("). So, you can just do:"),Fn=d(),k(At.$$.fragment),Yn=d(),Va=r("li"),kt=r("p"),Vn=o("LoRA parameters that have separate identifiers for the UNet and the text encoder such as: "),Dt=r("a"),Xa=r("code"),Xn=o('"sayakpaul/dreambooth"'),Jn=o("."),this.h()},l(e){const i=Oi('[data-svelte="svelte-1phssyn"]',document.head);p=n(i,"META",{name:!0,content:!0}),i.forEach(a),y=u(e),c=n(e,"H1",{class:!0});var Lt=l(c);b=n(Lt,"A",{id:!0,class:!0,href:!0});var Ja=l(b);v=n(Ja,"SPAN",{});var Ka=l(v);D(m.$$.fragment,Ka),Ka.forEach(a),Ja.forEach(a),g=u(Lt),E=n(Lt,"SPAN",{});var Za=l(E);P=s(Za,"Low-Rank Adaptation of Large Language Models (LoRA)"),Za.forEach(a),Lt.forEach(a),x=u(e),D(S.$$.fragment,e),w=u(e),D($.$$.fragment,e),O=u(e),A=n(e,"P",{});var ie=l(A);C=n(ie,"A",{href:!0,rel:!0});var Qa=l(C);V=s(Qa,"Low-Rank Adaptation of Large Language Models (LoRA)"),Qa.forEach(a),M=s(ie," is a training method that accelerates the training of large models while consuming less memory. It adds pairs of rank-decomposition weight matrices (called "),B=n(ie,"STRONG",{});var al=l(B);X=s(al,"update matrices"),al.forEach(a),N=s(ie,") to existing weights, and "),_=n(ie,"STRONG",{});var ol=l(_);pe=s(ol,"only"),ol.forEach(a),fe=s(ie," trains those newly added weights. This has a couple of advantages:"),ie.forEach(a),J=u(e),q=n(e,"UL",{});var Ne=l(q);H=n(Ne,"LI",{});var Xo=l(H);de=s(Xo,"Previous pretrained weights are kept frozen so the model is not as prone to "),He=n(Xo,"A",{href:!0,rel:!0});var sl=l(He);hs=s(sl,"catastrophic forgetting"),sl.forEach(a),ps=s(Xo,"."),Xo.forEach(a),fs=u(Ne),ra=n(Ne,"LI",{});var rl=l(ra);ds=s(rl,"Rank-decomposition matrices have significantly fewer parameters than the original model, which means that trained LoRA weights are easily portable."),rl.forEach(a),us=u(Ne),ue=n(Ne,"LI",{});var Ft=l(ue);cs=s(Ft,"LoRA matrices are generally added to the attention layers of the original model. \u{1F9E8} Diffusers provides the "),jt=n(Ft,"A",{href:!0});var nl=l(jt);ms=s(nl,"load_attn_procs()"),nl.forEach(a),_s=s(Ft," method to load the LoRA weights into a model\u2019s attention layers. You can control the extent to which the model is adapted toward new training images via a "),na=n(Ft,"CODE",{});var ll=l(na);gs=s(ll,"scale"),ll.forEach(a),bs=s(Ft," parameter."),Ft.forEach(a),ws=u(Ne),la=n(Ne,"LI",{});var il=l(la);vs=s(il,"The greater memory-efficiency allows you to run fine-tuning on consumer GPUs like the Tesla T4, RTX 3080 or even the RTX 2080 Ti! GPUs like the T4 are free and readily accessible in Kaggle or Google Colab notebooks."),il.forEach(a),Ne.forEach(a),ao=u(e),D(ye.$$.fragment,e),oo=u(e),G=n(e,"P",{});var ve=l(G);Ge=n(ve,"A",{href:!0,rel:!0});var hl=l(Ge);ys=s(hl,"cloneofsimo"),hl.forEach(a),$s=s(ve," was the first to try out LoRA training for Stable Diffusion in the popular "),ze=n(ve,"A",{href:!0,rel:!0});var pl=l(ze);Es=s(pl,"lora"),pl.forEach(a),As=s(ve," GitHub repository. \u{1F9E8} Diffusers now supports finetuning with LoRA for "),We=n(ve,"A",{href:!0,rel:!0});var fl=l(We);ks=s(fl,"text-to-image generation"),fl.forEach(a),Ds=s(ve," and "),Fe=n(ve,"A",{href:!0,rel:!0});var dl=l(Fe);Ls=s(dl,"DreamBooth"),dl.forEach(a),Rs=s(ve,". This guide will show you how to do both."),ve.forEach(a),so=u(e),$e=n(e,"P",{});var Jo=l($e);js=s(Jo,"If you\u2019d like to store or share your model with the community, login to your Hugging Face account (create "),Tt=n(Jo,"A",{href:!0});var ul=l(Tt);Ts=s(ul,"one"),ul.forEach(a),Ps=s(Jo," if you don\u2019t have one already):"),Jo.forEach(a),ro=u(e),D(Ye.$$.fragment,e),no=u(e),ce=n(e,"H2",{class:!0});var Ko=l(ce);Ee=n(Ko,"A",{id:!0,class:!0,href:!0});var cl=l(Ee);ia=n(cl,"SPAN",{});var ml=l(ia);D(Ve.$$.fragment,ml),ml.forEach(a),cl.forEach(a),xs=u(Ko),ha=n(Ko,"SPAN",{});var _l=l(ha);Ss=s(_l,"Text-to-image"),_l.forEach(a),Ko.forEach(a),lo=u(e),Pt=n(e,"P",{});var gl=l(Pt);qs=s(gl,"Finetuning a model like Stable Diffusion, which has billions of parameters, can be slow and difficult. With LoRA, it is much easier and faster to finetune a diffusion model. It can run on hardware with as little as 11GB of GPU RAM without resorting to tricks such as 8-bit optimizers."),gl.forEach(a),io=u(e),me=n(e,"H3",{class:!0});var Zo=l(me);Ae=n(Zo,"A",{id:!0,class:!0,href:!0});var bl=l(Ae);pa=n(bl,"SPAN",{});var wl=l(pa);D(Xe.$$.fragment,wl),wl.forEach(a),bl.forEach(a),Os=u(Zo),fa=n(Zo,"SPAN",{});var vl=l(fa);Cs=s(vl,"Training"),vl.forEach(a),Zo.forEach(a),ho=u(e),K=n(e,"P",{});var Yt=l(K);Ms=s(Yt,"Let\u2019s finetune "),Je=n(Yt,"A",{href:!0,rel:!0});var yl=l(Je);da=n(yl,"CODE",{});var $l=l(da);Ns=s($l,"stable-diffusion-v1-5"),$l.forEach(a),yl.forEach(a),Is=s(Yt," on the "),Ke=n(Yt,"A",{href:!0,rel:!0});var El=l(Ke);Us=s(El,"Pok\xE9mon BLIP captions"),El.forEach(a),Bs=s(Yt," dataset to generate your own Pok\xE9mon."),Yt.forEach(a),po=u(e),U=n(e,"P",{});var he=l(U);Hs=s(he,"Specify the "),ua=n(he,"CODE",{});var Al=l(ua);Gs=s(Al,"MODEL_NAME"),Al.forEach(a),zs=s(he," environment variable (either a Hub model repository id or a path to the directory containing the model weights) and pass it to the "),Ze=n(he,"A",{href:!0,rel:!0});var kl=l(Ze);ca=n(kl,"CODE",{});var Dl=l(ca);Ws=s(Dl,"pretrained_model_name_or_path"),Dl.forEach(a),kl.forEach(a),Fs=s(he," argument. You\u2019ll also need to set the "),ma=n(he,"CODE",{});var Ll=l(ma);Ys=s(Ll,"DATASET_NAME"),Ll.forEach(a),Vs=s(he," environment variable to the name of the dataset you want to train on. To use your own dataset, take a look at the "),xt=n(he,"A",{href:!0});var Rl=l(xt);Xs=s(Rl,"Create a dataset for training"),Rl.forEach(a),Js=s(he," guide."),he.forEach(a),fo=u(e),Z=n(e,"P",{});var Vt=l(Z);Ks=s(Vt,"The "),_a=n(Vt,"CODE",{});var jl=l(_a);Zs=s(jl,"OUTPUT_DIR"),jl.forEach(a),Qs=s(Vt," and "),ga=n(Vt,"CODE",{});var Tl=l(ga);er=s(Tl,"HUB_MODEL_ID"),Tl.forEach(a),tr=s(Vt," variables are optional and specify where to save the model to on the Hub:"),Vt.forEach(a),uo=u(e),D(Qe.$$.fragment,e),co=u(e),St=n(e,"P",{});var Pl=l(St);ar=s(Pl,"There are some flags to be aware of before you start training:"),Pl.forEach(a),mo=u(e),Q=n(e,"UL",{});var Xt=l(Q);qt=n(Xt,"LI",{});var Kn=l(qt);ba=n(Kn,"CODE",{});var xl=l(ba);or=s(xl,"--push_to_hub"),xl.forEach(a),sr=s(Kn," stores the trained LoRA embeddings on the Hub."),Kn.forEach(a),rr=u(Xt),ke=n(Xt,"LI",{});var eo=l(ke);wa=n(eo,"CODE",{});var Sl=l(wa);nr=s(Sl,"--report_to=wandb"),Sl.forEach(a),lr=s(eo," reports and logs the training results to your Weights & Biases dashboard (as an example, take a look at this "),et=n(eo,"A",{href:!0,rel:!0});var ql=l(et);ir=s(ql,"report"),ql.forEach(a),hr=s(eo,")."),eo.forEach(a),pr=u(Xt),Ot=n(Xt,"LI",{});var Zn=l(Ot);va=n(Zn,"CODE",{});var Ol=l(va);fr=s(Ol,"--learning_rate=1e-04"),Ol.forEach(a),dr=s(Zn,", you can afford to use a higher learning rate than you normally would with LoRA."),Zn.forEach(a),Xt.forEach(a),_o=u(e),ee=n(e,"P",{});var Jt=l(ee);ur=s(Jt,"Now you\u2019re ready to launch the training (you can find the full training script "),tt=n(Jt,"A",{href:!0,rel:!0});var Cl=l(tt);cr=s(Cl,"here"),Cl.forEach(a),mr=s(Jt,"). Training takes about 5 hours on a 2080 Ti GPU with 11GB of RAM, and it\u2019ll create and save model checkpoints and the "),ya=n(Jt,"CODE",{});var Ml=l(ya);_r=s(Ml,"pytorch_lora_weights"),Ml.forEach(a),gr=s(Jt," in your repository."),Jt.forEach(a),go=u(e),D(at.$$.fragment,e),bo=u(e),_e=n(e,"H3",{class:!0});var Qo=l(_e);De=n(Qo,"A",{id:!0,class:!0,href:!0});var Nl=l(De);$a=n(Nl,"SPAN",{});var Il=l($a);D(ot.$$.fragment,Il),Il.forEach(a),Nl.forEach(a),br=u(Qo),Ea=n(Qo,"SPAN",{});var Ul=l(Ea);wr=s(Ul,"Inference"),Ul.forEach(a),Qo.forEach(a),wo=u(e),te=n(e,"P",{});var Kt=l(te);vr=s(Kt,"Now you can use the model for inference by loading the base model in the "),Ct=n(Kt,"A",{href:!0});var Bl=l(Ct);yr=s(Bl,"StableDiffusionPipeline"),Bl.forEach(a),$r=s(Kt," and then the "),Mt=n(Kt,"A",{href:!0});var Hl=l(Mt);Er=s(Hl,"DPMSolverMultistepScheduler"),Hl.forEach(a),Ar=s(Kt,":"),Kt.forEach(a),vo=u(e),D(st.$$.fragment,e),yo=u(e),ae=n(e,"P",{});var Zt=l(ae);kr=s(Zt,"Load the LoRA weights from your finetuned model "),Aa=n(Zt,"EM",{});var Gl=l(Aa);Dr=s(Gl,"on top of the base model weights"),Gl.forEach(a),Lr=s(Zt,", and then move the pipeline to a GPU for faster inference. When you merge the LoRA weights with the frozen pretrained model weights, you can optionally adjust how much of the weights to merge with the "),ka=n(Zt,"CODE",{});var zl=l(ka);Rr=s(zl,"scale"),zl.forEach(a),jr=s(Zt," parameter:"),Zt.forEach(a),$o=u(e),D(Le.$$.fragment,e),Eo=u(e),D(rt.$$.fragment,e),Ao=u(e),D(Re.$$.fragment,e),ko=u(e),ge=n(e,"H2",{class:!0});var es=l(ge);je=n(es,"A",{id:!0,class:!0,href:!0});var Wl=l(je);Da=n(Wl,"SPAN",{});var Fl=l(Da);D(nt.$$.fragment,Fl),Fl.forEach(a),Wl.forEach(a),Tr=u(es),La=n(es,"SPAN",{});var Yl=l(La);Pr=s(Yl,"DreamBooth"),Yl.forEach(a),es.forEach(a),Do=u(e),lt=n(e,"P",{});var Qn=l(lt);it=n(Qn,"A",{href:!0,rel:!0});var Vl=l(it);xr=s(Vl,"DreamBooth"),Vl.forEach(a),Sr=s(Qn," is a finetuning technique for personalizing a text-to-image model like Stable Diffusion to generate photorealistic images of a subject in different contexts, given a few images of the subject. However, DreamBooth is very sensitive to hyperparameters and it is easy to overfit. Some important hyperparameters to consider include those that affect the training time (learning rate, number of training steps), and inference time (number of steps, scheduler type)."),Qn.forEach(a),Lo=u(e),D(Te.$$.fragment,e),Ro=u(e),be=n(e,"H3",{class:!0});var ts=l(be);Pe=n(ts,"A",{id:!0,class:!0,href:!0});var Xl=l(Pe);Ra=n(Xl,"SPAN",{});var Jl=l(Ra);D(ht.$$.fragment,Jl),Jl.forEach(a),Xl.forEach(a),qr=u(ts),ja=n(ts,"SPAN",{});var Kl=l(ja);Or=s(Kl,"Training"),Kl.forEach(a),ts.forEach(a),jo=u(e),z=n(e,"P",{});var Ie=l(z);Cr=s(Ie,"Let\u2019s finetune "),pt=n(Ie,"A",{href:!0,rel:!0});var Zl=l(pt);Ta=n(Zl,"CODE",{});var Ql=l(Ta);Mr=s(Ql,"stable-diffusion-v1-5"),Ql.forEach(a),Zl.forEach(a),Nr=s(Ie," with DreamBooth and LoRA with some \u{1F436} "),ft=n(Ie,"A",{href:!0,rel:!0});var ei=l(ft);Ir=s(ei,"dog images"),ei.forEach(a),Ur=s(Ie,". Download and save these images to a directory. To use your own dataset, take a look at the "),Nt=n(Ie,"A",{href:!0});var ti=l(Nt);Br=s(ti,"Create a dataset for training"),ti.forEach(a),Hr=s(Ie," guide."),Ie.forEach(a),To=u(e),W=n(e,"P",{});var Ue=l(W);Gr=s(Ue,"To start, specify the "),Pa=n(Ue,"CODE",{});var ai=l(Pa);zr=s(ai,"MODEL_NAME"),ai.forEach(a),Wr=s(Ue," environment variable (either a Hub model repository id or a path to the directory containing the model weights) and pass it to the "),dt=n(Ue,"A",{href:!0,rel:!0});var oi=l(dt);xa=n(oi,"CODE",{});var si=l(xa);Fr=s(si,"pretrained_model_name_or_path"),si.forEach(a),oi.forEach(a),Yr=s(Ue," argument. You\u2019ll also need to set "),Sa=n(Ue,"CODE",{});var ri=l(Sa);Vr=s(ri,"INSTANCE_DIR"),ri.forEach(a),Xr=s(Ue," to the path of the directory containing the images."),Ue.forEach(a),Po=u(e),xe=n(e,"P",{});var as=l(xe);Jr=s(as,"The "),qa=n(as,"CODE",{});var ni=l(qa);Kr=s(ni,"OUTPUT_DIR"),ni.forEach(a),Zr=s(as," variables is optional and specifies where to save the model to on the Hub:"),as.forEach(a),xo=u(e),D(ut.$$.fragment,e),So=u(e),It=n(e,"P",{});var li=l(It);Qr=s(li,"There are some flags to be aware of before you start training:"),li.forEach(a),qo=u(e),oe=n(e,"UL",{});var Qt=l(oe);Ut=n(Qt,"LI",{});var el=l(Ut);Oa=n(el,"CODE",{});var ii=l(Oa);en=s(ii,"--push_to_hub"),ii.forEach(a),tn=s(el," stores the trained LoRA embeddings on the Hub."),el.forEach(a),an=u(Qt),Se=n(Qt,"LI",{});var to=l(Se);Ca=n(to,"CODE",{});var hi=l(Ca);on=s(hi,"--report_to=wandb"),hi.forEach(a),sn=s(to," reports and logs the training results to your Weights & Biases dashboard (as an example, take a look at this "),ct=n(to,"A",{href:!0,rel:!0});var pi=l(ct);rn=s(pi,"report"),pi.forEach(a),nn=s(to,")."),to.forEach(a),ln=u(Qt),Bt=n(Qt,"LI",{});var tl=l(Bt);Ma=n(tl,"CODE",{});var fi=l(Ma);hn=s(fi,"--learning_rate=1e-04"),fi.forEach(a),pn=s(tl,", you can afford to use a higher learning rate than you normally would with LoRA."),tl.forEach(a),Qt.forEach(a),Oo=u(e),se=n(e,"P",{});var ea=l(se);fn=s(ea,"Now you\u2019re ready to launch the training (you can find the full training script "),mt=n(ea,"A",{href:!0,rel:!0});var di=l(mt);dn=s(di,"here"),di.forEach(a),un=s(ea,"). The script creates and saves model checkpoints and the "),Na=n(ea,"CODE",{});var ui=l(Na);cn=s(ui,"pytorch_lora_weights.bin"),ui.forEach(a),mn=s(ea," file in your repository."),ea.forEach(a),Co=u(e),re=n(e,"P",{});var ta=l(re);_n=s(ta,`It\u2019s also possible to additionally fine-tune the text encoder with LoRA. This, in most cases, leads
to better results with a slight increase in the compute. To allow fine-tuning the text encoder with LoRA,
specify the `),Ia=n(ta,"CODE",{});var ci=l(Ia);gn=s(ci,"--train_text_encoder"),ci.forEach(a),bn=s(ta," while launching the "),Ua=n(ta,"CODE",{});var mi=l(Ua);wn=s(mi,"train_dreambooth_lora.py"),mi.forEach(a),vn=s(ta," script."),ta.forEach(a),Mo=u(e),D(_t.$$.fragment,e),No=u(e),we=n(e,"H3",{class:!0});var os=l(we);qe=n(os,"A",{id:!0,class:!0,href:!0});var _i=l(qe);Ba=n(_i,"SPAN",{});var gi=l(Ba);D(gt.$$.fragment,gi),gi.forEach(a),_i.forEach(a),yn=u(os),Ha=n(os,"SPAN",{});var bi=l(Ha);$n=s(bi,"Inference"),bi.forEach(a),os.forEach(a),Io=u(e),Oe=n(e,"P",{});var ss=l(Oe);En=s(ss,"Now you can use the model for inference by loading the base model in the "),Ht=n(ss,"A",{href:!0});var wi=l(Ht);An=s(wi,"StableDiffusionPipeline"),wi.forEach(a),kn=s(ss,":"),ss.forEach(a),Uo=u(e),D(bt.$$.fragment,e),Bo=u(e),ne=n(e,"P",{});var aa=l(ne);Dn=s(aa,"Load the LoRA weights from your finetuned DreamBooth model "),Ga=n(aa,"EM",{});var vi=l(Ga);Ln=s(vi,"on top of the base model weights"),vi.forEach(a),Rn=s(aa,", and then move the pipeline to a GPU for faster inference. When you merge the LoRA weights with the frozen pretrained model weights, you can optionally adjust how much of the weights to merge with the "),za=n(aa,"CODE",{});var yi=l(za);jn=s(yi,"scale"),yi.forEach(a),Tn=s(aa," parameter:"),aa.forEach(a),Ho=u(e),D(Ce.$$.fragment,e),Go=u(e),D(wt.$$.fragment,e),zo=u(e),le=n(e,"P",{});var oa=l(le);Pn=s(oa,"If you used "),Wa=n(oa,"CODE",{});var $i=l(Wa);xn=s($i,"--train_text_encoder"),$i.forEach(a),Sn=s(oa," during training, then use "),Fa=n(oa,"CODE",{});var Ei=l(Fa);qn=s(Ei,"pipe.load_lora_weights()"),Ei.forEach(a),On=s(oa,` to load the LoRA
weights. For example:`),oa.forEach(a),Wo=u(e),D(vt.$$.fragment,e),Fo=u(e),F=n(e,"P",{});var Be=l(F);Cn=s(Be,"Note that the use of "),Gt=n(Be,"A",{href:!0});var Ai=l(Gt);Mn=s(Ai,"load_lora_weights()"),Ai.forEach(a),Nn=s(Be," is preferred to "),zt=n(Be,"A",{href:!0});var ki=l(zt);In=s(ki,"load_attn_procs()"),ki.forEach(a),Un=s(Be,` for loading LoRA parameters. This is because
`),Wt=n(Be,"A",{href:!0});var Di=l(Wt);Bn=s(Di,"load_lora_weights()"),Di.forEach(a),Hn=s(Be," can handle the following situations:"),Be.forEach(a),Yo=u(e),Me=n(e,"UL",{});var rs=l(Me);yt=n(rs,"LI",{});var ns=l(yt);$t=n(ns,"P",{});var ls=l($t);Gn=s(ls,"LoRA parameters that don\u2019t have separate identifiers for the UNet and the text encoder (such as "),Et=n(ls,"A",{href:!0,rel:!0});var Li=l(Et);Ya=n(Li,"CODE",{});var Ri=l(Ya);zn=s(Ri,'"patrickvonplaten/lora_dreambooth_dog_example"'),Ri.forEach(a),Li.forEach(a),Wn=s(ls,"). So, you can just do:"),ls.forEach(a),Fn=u(ns),D(At.$$.fragment,ns),ns.forEach(a),Yn=u(rs),Va=n(rs,"LI",{});var ji=l(Va);kt=n(ji,"P",{});var is=l(kt);Vn=s(is,"LoRA parameters that have separate identifiers for the UNet and the text encoder such as: "),Dt=n(is,"A",{href:!0,rel:!0});var Ti=l(Dt);Xa=n(Ti,"CODE",{});var Pi=l(Xa);Xn=s(Pi,'"sayakpaul/dreambooth"'),Pi.forEach(a),Ti.forEach(a),Jn=s(is,"."),is.forEach(a),ji.forEach(a),rs.forEach(a),this.h()},h(){f(p,"name","hf:doc:metadata"),f(p,"content",JSON.stringify(Fi)),f(b,"id","lowrank-adaptation-of-large-language-models-lora"),f(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(b,"href","#lowrank-adaptation-of-large-language-models-lora"),f(c,"class","relative group"),f(C,"href","https://arxiv.org/abs/2106.09685"),f(C,"rel","nofollow"),f(He,"href","https://www.pnas.org/doi/10.1073/pnas.1611835114"),f(He,"rel","nofollow"),f(jt,"href","/docs/diffusers/pr_185/en/api/loaders#diffusers.loaders.UNet2DConditionLoadersMixin.load_attn_procs"),f(Ge,"href","https://github.com/cloneofsimo"),f(Ge,"rel","nofollow"),f(ze,"href","https://github.com/cloneofsimo/lora"),f(ze,"rel","nofollow"),f(We,"href","https://github.com/huggingface/diffusers/tree/main/examples/text_to_image#training-with-lora"),f(We,"rel","nofollow"),f(Fe,"href","https://github.com/huggingface/diffusers/tree/main/examples/dreambooth#training-with-low-rank-adaptation-of-large-language-models-lora"),f(Fe,"rel","nofollow"),f(Tt,"href","hf.co/join"),f(Ee,"id","texttoimage"),f(Ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(Ee,"href","#texttoimage"),f(ce,"class","relative group"),f(Ae,"id","text-to-image-training"),f(Ae,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(Ae,"href","#text-to-image-training"),f(me,"class","relative group"),f(Je,"href","https://huggingface.co/runwayml/stable-diffusion-v1-5"),f(Je,"rel","nofollow"),f(Ke,"href","https://huggingface.co/datasets/lambdalabs/pokemon-blip-captions"),f(Ke,"rel","nofollow"),f(Ze,"href","https://huggingface.co/docs/diffusers/en/api/diffusion_pipeline#diffusers.DiffusionPipeline.from_pretrained.pretrained_model_name_or_path"),f(Ze,"rel","nofollow"),f(xt,"href","create_dataset"),f(et,"href","https://wandb.ai/pcuenq/text2image-fine-tune/runs/b4k1w0tn?workspace=user-pcuenq"),f(et,"rel","nofollow"),f(tt,"href","https://github.com/huggingface/diffusers/blob/main/examples/text_to_image/train_text_to_image_lora.py"),f(tt,"rel","nofollow"),f(De,"id","text-to-image-inference"),f(De,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(De,"href","#text-to-image-inference"),f(_e,"class","relative group"),f(Ct,"href","/docs/diffusers/pr_185/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline"),f(Mt,"href","/docs/diffusers/pr_185/en/api/schedulers/multistep_dpm_solver#diffusers.DPMSolverMultistepScheduler"),f(je,"id","dreambooth"),f(je,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(je,"href","#dreambooth"),f(ge,"class","relative group"),f(it,"href","https://arxiv.org/abs/2208.12242"),f(it,"rel","nofollow"),f(Pe,"id","dreambooth-training"),f(Pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(Pe,"href","#dreambooth-training"),f(be,"class","relative group"),f(pt,"href","https://huggingface.co/runwayml/stable-diffusion-v1-5"),f(pt,"rel","nofollow"),f(ft,"href","https://drive.google.com/drive/folders/1BO_dyz-p65qhBRRMRA4TbZ8qW4rB99JZ"),f(ft,"rel","nofollow"),f(Nt,"href","create_dataset"),f(dt,"href","https://huggingface.co/docs/diffusers/en/api/diffusion_pipeline#diffusers.DiffusionPipeline.from_pretrained.pretrained_model_name_or_path"),f(dt,"rel","nofollow"),f(ct,"href","https://wandb.ai/pcuenq/text2image-fine-tune/runs/b4k1w0tn?workspace=user-pcuenq"),f(ct,"rel","nofollow"),f(mt,"href","https://github.com/huggingface/diffusers/blob/main/examples/dreambooth/train_dreambooth_lora.py"),f(mt,"rel","nofollow"),f(qe,"id","dreambooth-inference"),f(qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(qe,"href","#dreambooth-inference"),f(we,"class","relative group"),f(Ht,"href","/docs/diffusers/pr_185/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline"),f(Gt,"href","/docs/diffusers/pr_185/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.load_lora_weights"),f(zt,"href","/docs/diffusers/pr_185/en/api/loaders#diffusers.loaders.UNet2DConditionLoadersMixin.load_attn_procs"),f(Wt,"href","/docs/diffusers/pr_185/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.load_lora_weights"),f(Et,"href","https://huggingface.co/patrickvonplaten/lora_dreambooth_dog_example"),f(Et,"rel","nofollow"),f(Dt,"href","https://huggingface.co/sayakpaul/dreambooth"),f(Dt,"rel","nofollow")},m(e,i){t(document.head,p),h(e,y,i),h(e,c,i),t(c,b),t(b,v),L(m,v,null),t(c,g),t(c,E),t(E,P),h(e,x,i),L(S,e,i),h(e,w,i),L($,e,i),h(e,O,i),h(e,A,i),t(A,C),t(C,V),t(A,M),t(A,B),t(B,X),t(A,N),t(A,_),t(_,pe),t(A,fe),h(e,J,i),h(e,q,i),t(q,H),t(H,de),t(H,He),t(He,hs),t(H,ps),t(q,fs),t(q,ra),t(ra,ds),t(q,us),t(q,ue),t(ue,cs),t(ue,jt),t(jt,ms),t(ue,_s),t(ue,na),t(na,gs),t(ue,bs),t(q,ws),t(q,la),t(la,vs),h(e,ao,i),L(ye,e,i),h(e,oo,i),h(e,G,i),t(G,Ge),t(Ge,ys),t(G,$s),t(G,ze),t(ze,Es),t(G,As),t(G,We),t(We,ks),t(G,Ds),t(G,Fe),t(Fe,Ls),t(G,Rs),h(e,so,i),h(e,$e,i),t($e,js),t($e,Tt),t(Tt,Ts),t($e,Ps),h(e,ro,i),L(Ye,e,i),h(e,no,i),h(e,ce,i),t(ce,Ee),t(Ee,ia),L(Ve,ia,null),t(ce,xs),t(ce,ha),t(ha,Ss),h(e,lo,i),h(e,Pt,i),t(Pt,qs),h(e,io,i),h(e,me,i),t(me,Ae),t(Ae,pa),L(Xe,pa,null),t(me,Os),t(me,fa),t(fa,Cs),h(e,ho,i),h(e,K,i),t(K,Ms),t(K,Je),t(Je,da),t(da,Ns),t(K,Is),t(K,Ke),t(Ke,Us),t(K,Bs),h(e,po,i),h(e,U,i),t(U,Hs),t(U,ua),t(ua,Gs),t(U,zs),t(U,Ze),t(Ze,ca),t(ca,Ws),t(U,Fs),t(U,ma),t(ma,Ys),t(U,Vs),t(U,xt),t(xt,Xs),t(U,Js),h(e,fo,i),h(e,Z,i),t(Z,Ks),t(Z,_a),t(_a,Zs),t(Z,Qs),t(Z,ga),t(ga,er),t(Z,tr),h(e,uo,i),L(Qe,e,i),h(e,co,i),h(e,St,i),t(St,ar),h(e,mo,i),h(e,Q,i),t(Q,qt),t(qt,ba),t(ba,or),t(qt,sr),t(Q,rr),t(Q,ke),t(ke,wa),t(wa,nr),t(ke,lr),t(ke,et),t(et,ir),t(ke,hr),t(Q,pr),t(Q,Ot),t(Ot,va),t(va,fr),t(Ot,dr),h(e,_o,i),h(e,ee,i),t(ee,ur),t(ee,tt),t(tt,cr),t(ee,mr),t(ee,ya),t(ya,_r),t(ee,gr),h(e,go,i),L(at,e,i),h(e,bo,i),h(e,_e,i),t(_e,De),t(De,$a),L(ot,$a,null),t(_e,br),t(_e,Ea),t(Ea,wr),h(e,wo,i),h(e,te,i),t(te,vr),t(te,Ct),t(Ct,yr),t(te,$r),t(te,Mt),t(Mt,Er),t(te,Ar),h(e,vo,i),L(st,e,i),h(e,yo,i),h(e,ae,i),t(ae,kr),t(ae,Aa),t(Aa,Dr),t(ae,Lr),t(ae,ka),t(ka,Rr),t(ae,jr),h(e,$o,i),L(Le,e,i),h(e,Eo,i),L(rt,e,i),h(e,Ao,i),L(Re,e,i),h(e,ko,i),h(e,ge,i),t(ge,je),t(je,Da),L(nt,Da,null),t(ge,Tr),t(ge,La),t(La,Pr),h(e,Do,i),h(e,lt,i),t(lt,it),t(it,xr),t(lt,Sr),h(e,Lo,i),L(Te,e,i),h(e,Ro,i),h(e,be,i),t(be,Pe),t(Pe,Ra),L(ht,Ra,null),t(be,qr),t(be,ja),t(ja,Or),h(e,jo,i),h(e,z,i),t(z,Cr),t(z,pt),t(pt,Ta),t(Ta,Mr),t(z,Nr),t(z,ft),t(ft,Ir),t(z,Ur),t(z,Nt),t(Nt,Br),t(z,Hr),h(e,To,i),h(e,W,i),t(W,Gr),t(W,Pa),t(Pa,zr),t(W,Wr),t(W,dt),t(dt,xa),t(xa,Fr),t(W,Yr),t(W,Sa),t(Sa,Vr),t(W,Xr),h(e,Po,i),h(e,xe,i),t(xe,Jr),t(xe,qa),t(qa,Kr),t(xe,Zr),h(e,xo,i),L(ut,e,i),h(e,So,i),h(e,It,i),t(It,Qr),h(e,qo,i),h(e,oe,i),t(oe,Ut),t(Ut,Oa),t(Oa,en),t(Ut,tn),t(oe,an),t(oe,Se),t(Se,Ca),t(Ca,on),t(Se,sn),t(Se,ct),t(ct,rn),t(Se,nn),t(oe,ln),t(oe,Bt),t(Bt,Ma),t(Ma,hn),t(Bt,pn),h(e,Oo,i),h(e,se,i),t(se,fn),t(se,mt),t(mt,dn),t(se,un),t(se,Na),t(Na,cn),t(se,mn),h(e,Co,i),h(e,re,i),t(re,_n),t(re,Ia),t(Ia,gn),t(re,bn),t(re,Ua),t(Ua,wn),t(re,vn),h(e,Mo,i),L(_t,e,i),h(e,No,i),h(e,we,i),t(we,qe),t(qe,Ba),L(gt,Ba,null),t(we,yn),t(we,Ha),t(Ha,$n),h(e,Io,i),h(e,Oe,i),t(Oe,En),t(Oe,Ht),t(Ht,An),t(Oe,kn),h(e,Uo,i),L(bt,e,i),h(e,Bo,i),h(e,ne,i),t(ne,Dn),t(ne,Ga),t(Ga,Ln),t(ne,Rn),t(ne,za),t(za,jn),t(ne,Tn),h(e,Ho,i),L(Ce,e,i),h(e,Go,i),L(wt,e,i),h(e,zo,i),h(e,le,i),t(le,Pn),t(le,Wa),t(Wa,xn),t(le,Sn),t(le,Fa),t(Fa,qn),t(le,On),h(e,Wo,i),L(vt,e,i),h(e,Fo,i),h(e,F,i),t(F,Cn),t(F,Gt),t(Gt,Mn),t(F,Nn),t(F,zt),t(zt,In),t(F,Un),t(F,Wt),t(Wt,Bn),t(F,Hn),h(e,Yo,i),h(e,Me,i),t(Me,yt),t(yt,$t),t($t,Gn),t($t,Et),t(Et,Ya),t(Ya,zn),t($t,Wn),t(yt,Fn),L(At,yt,null),t(Me,Yn),t(Me,Va),t(Va,kt),t(kt,Vn),t(kt,Dt),t(Dt,Xa),t(Xa,Xn),t(kt,Jn),Vo=!0},p(e,[i]){const Lt={};i&2&&(Lt.$$scope={dirty:i,ctx:e}),$.$set(Lt);const Ja={};i&2&&(Ja.$$scope={dirty:i,ctx:e}),ye.$set(Ja);const Ka={};i&2&&(Ka.$$scope={dirty:i,ctx:e}),Le.$set(Ka);const Za={};i&2&&(Za.$$scope={dirty:i,ctx:e}),Re.$set(Za);const ie={};i&2&&(ie.$$scope={dirty:i,ctx:e}),Te.$set(ie);const Qa={};i&2&&(Qa.$$scope={dirty:i,ctx:e}),Ce.$set(Qa)},i(e){Vo||(R(m.$$.fragment,e),R(S.$$.fragment,e),R($.$$.fragment,e),R(ye.$$.fragment,e),R(Ye.$$.fragment,e),R(Ve.$$.fragment,e),R(Xe.$$.fragment,e),R(Qe.$$.fragment,e),R(at.$$.fragment,e),R(ot.$$.fragment,e),R(st.$$.fragment,e),R(Le.$$.fragment,e),R(rt.$$.fragment,e),R(Re.$$.fragment,e),R(nt.$$.fragment,e),R(Te.$$.fragment,e),R(ht.$$.fragment,e),R(ut.$$.fragment,e),R(_t.$$.fragment,e),R(gt.$$.fragment,e),R(bt.$$.fragment,e),R(Ce.$$.fragment,e),R(wt.$$.fragment,e),R(vt.$$.fragment,e),R(At.$$.fragment,e),Vo=!0)},o(e){j(m.$$.fragment,e),j(S.$$.fragment,e),j($.$$.fragment,e),j(ye.$$.fragment,e),j(Ye.$$.fragment,e),j(Ve.$$.fragment,e),j(Xe.$$.fragment,e),j(Qe.$$.fragment,e),j(at.$$.fragment,e),j(ot.$$.fragment,e),j(st.$$.fragment,e),j(Le.$$.fragment,e),j(rt.$$.fragment,e),j(Re.$$.fragment,e),j(nt.$$.fragment,e),j(Te.$$.fragment,e),j(ht.$$.fragment,e),j(ut.$$.fragment,e),j(_t.$$.fragment,e),j(gt.$$.fragment,e),j(bt.$$.fragment,e),j(Ce.$$.fragment,e),j(wt.$$.fragment,e),j(vt.$$.fragment,e),j(At.$$.fragment,e),Vo=!1},d(e){a(p),e&&a(y),e&&a(c),T(m),e&&a(x),T(S,e),e&&a(w),T($,e),e&&a(O),e&&a(A),e&&a(J),e&&a(q),e&&a(ao),T(ye,e),e&&a(oo),e&&a(G),e&&a(so),e&&a($e),e&&a(ro),T(Ye,e),e&&a(no),e&&a(ce),T(Ve),e&&a(lo),e&&a(Pt),e&&a(io),e&&a(me),T(Xe),e&&a(ho),e&&a(K),e&&a(po),e&&a(U),e&&a(fo),e&&a(Z),e&&a(uo),T(Qe,e),e&&a(co),e&&a(St),e&&a(mo),e&&a(Q),e&&a(_o),e&&a(ee),e&&a(go),T(at,e),e&&a(bo),e&&a(_e),T(ot),e&&a(wo),e&&a(te),e&&a(vo),T(st,e),e&&a(yo),e&&a(ae),e&&a($o),T(Le,e),e&&a(Eo),T(rt,e),e&&a(Ao),T(Re,e),e&&a(ko),e&&a(ge),T(nt),e&&a(Do),e&&a(lt),e&&a(Lo),T(Te,e),e&&a(Ro),e&&a(be),T(ht),e&&a(jo),e&&a(z),e&&a(To),e&&a(W),e&&a(Po),e&&a(xe),e&&a(xo),T(ut,e),e&&a(So),e&&a(It),e&&a(qo),e&&a(oe),e&&a(Oo),e&&a(se),e&&a(Co),e&&a(re),e&&a(Mo),T(_t,e),e&&a(No),e&&a(we),T(gt),e&&a(Io),e&&a(Oe),e&&a(Uo),T(bt,e),e&&a(Bo),e&&a(ne),e&&a(Ho),T(Ce,e),e&&a(Go),T(wt,e),e&&a(zo),e&&a(le),e&&a(Wo),T(vt,e),e&&a(Fo),e&&a(F),e&&a(Yo),e&&a(Me),T(At)}}}const Fi={local:"lowrank-adaptation-of-large-language-models-lora",sections:[{local:"texttoimage",sections:[{local:"text-to-image-training",title:"Training"},{local:"text-to-image-inference",title:"Inference"}],title:"Text-to-image"},{local:"dreambooth",sections:[{local:"dreambooth-training",title:"Training"},{local:"dreambooth-inference",title:"Inference"}],title:"DreamBooth"}],title:"Low-Rank Adaptation of Large Language Models (LoRA)"};function Yi(I){return Ci(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Qi extends xi{constructor(p){super();Si(this,p,Yi,Wi,qi,{})}}export{Qi as default,Fi as metadata};
